## Як запустити приклади на Raspberry Pi?

Кілька років тому, припускати, що кожен має комп'ютер із графічним процесором, було важко. Зараз більшість комп'ютерів вже мають GPU, хоча подекуди й для деяких навчальних класів це все ще не так.

Завдяки [Raspberry Pi Foundation](http://www.raspberrypi.org/) новий тип невеликих і дешевих комп'ютерів (близько 35$ за штуку) знайшов свій шлях до навчальних класів. Що ще важливіше для цілей цієї книги, [Raspberry Pi](http://www.raspberrypi.org/) постачається з гідним графічним процесором Broadcom, до якого можна отримати доступ безпосередньо з консолі. Я створив гнучкий інструмент для онлайн-кодування GLSL під назвою [**glslViewer**](https://github.com/patriciogonzalezvivo/glslViewer), який запускає всі приклади цієї книги. Ця програма має можливість автоматично оновлювати результат, коли користувач зберігає зміни у своєму коді. Що це значить? Ви можете редагувати код шейдеру, і щоразу, коли ви його зберігаєте, він буде автоматично скомпільований з оновленням вислідного зображення.

Створивши локальну копію репозиторію книги (див. [попередній розділ](../00/?lan=ua)) і встановивши [`glslViewer`](https://github.com/patriciogonzalezvivo/glslViewer), можна запускати приклади за допомогою команди `glslviewer`. Крім того, з додатковим прапорцем `-l` можна візуалізувати поточний приклад у кутку екрана під час редагування коду за допомогою будь-якого текстового редактора (наприклад, `nano`, `pico`, `vi`, `vim` або `emacs`) . Це також працює при підключенні через ssh/sftp.

Щоб встановити та налаштувати все необхідне на Raspberry Pi, після встановлення [Raspbian](https://www.raspberrypi.org/downloads/raspbian/) і входу в систему, введіть наступні команди:

```bash
sudo apt-get update
sudo apt-get upgrade
sudo apt-get install git-core glslviewer
cd ~
git clone https://github.com/patriciogonzalezvivo/thebookofshaders.git
cd thebookofshaders
```
