## Как принять участие в создании книги?

Благодарим за ваше желание помочь! Есть множество способов это сделать:

- Перевод
- Доработка [глоссария](https://github.com/patriciogonzalezvivo/thebookofshaders/tree/master/glossary)
- Редактирование
- Выкладывание ваших шейдеров в общий доступ с помощью [онлайн-редактора](http://editor.thebookofshaders.com/)

### Перевод

Книга написана на языке разметки [Markdown](https://daringfireball.net/projects/markdown/syntax), поэтому с её текстом очень легко работать.

1. Для начала перейдите в репозиторий по адресу [```github.com/patriciogonzalezvivo/thebookofshaders```](https://github.com/patriciogonzalezvivo/thebookofshaders). Осмотрите файлы и каталоги в нём. Легко заметить, что контент находится в файлах ```README.md``` и других файлах, названных заглавными буквами: ```TITLE.md```, ```SUMMARY.md``` и так далее. Так же вы заметите, что переводы находятся в файлах, имена которых заканчиваются двумя буквами, указывающими на язык перевода, например: ```README-jp.md```, ```README-es.md``` и прочие.

2. Форкните репозиторий и склонируйте его к себе на компьютер.

3. Продублируйте содержимое файлов, которые хотите перевести. Не забудьте добавить двухбуквенный код языка, на который переводите.

4. Переведите контент (см. **Примечания о переводе**).

5. Протестируйте (см. **Тестирование**).

6. Сделайте push в ваш собственный форк и затем создайте [пулл-реквест](https://help.github.com/articles/using-pull-requests/) в основной репозиторий.

#### Примечания о переводе

Не удаляйте и не изменяйте встроенные примеры, которые выглядят примерно так:

```html
    <div class="codeAndCanvas" data="grid-making.frag"></div>
```

или так:

```html
<div class="simpleFunction" data="y = mod(x,2.0);"></div>
```

#### Тестирование

Запустите локальный PHP-сервер в папке вашего локального репозитория:

```bash
php -S localhost:8000
```

Теперь в браузере перейдите по адресу ```localhost:8000```, зайдите на переводимую страницу и добавьте в конец адреса строку ```?lan=xx```, где ```xx``` - код языка, на который переводите.

Например, если вы переводите главу ```03``` на французский, значит вы работали над файлом ```03/README-fr.md```, который можно протестировать по адресу ```http://localhost:8000/03/?lan=fr```.

### Доработка глоссария

Этот раздел находится в разработке. Мы рады узнать ваше мнение о том, как сделать из него что-то полезное. Пишите нам на [@bookofshaders](https://twitter.com/bookofshaders).

### Редактирование

Все мы люди. Если вы видите ошибку - сообщите о ней и сделайте пулл-реквест, или откройте issue на гитхабе. Спасибо!

### Выкладывайте ваши шейдеры

Вы увидите множество ссылок на [онлайн-редактор](http://editor.thebookofshaders.com/) и написанный в нём код, встроенный в книгу. Если вы написали что-то стоящее, нажмите «Export» (или иконку ```⇪```) и скопируйте ссылку на код. Отправьте её на [@bookofshaders](https://twitter.com/bookofshaders) или [@kyndinfo](https://twitter.com/kyndinfo). Мы будем рады видеть ваш код и добавить его в [галерею примеров](https://thebookofshaders.com/examples/).
