## Як прийняти участь у розвитку книги?

Дякуємо за бажання співпрацювати! Для цього існує кілька способів:

- Переклад контенту
- Покращення та допрацювання [```глосарію```](https://github.com/patriciogonzalezvivo/thebookofshaders/tree/master/glossary)
- Редагування контенту
- Діліться своїми прикладами шейдерів через [онлайн-редактор](http://editor.thebookofshaders.com/)

### Переклад контенту

Ця книга написана мовою розмітки [Markdown](https://daringfireball.net/projects/markdown/syntax), тому її дуже легко редагувати та працювати з нею.

1. Для початку перейдіть до github-репозиторію за адресою  [```github.com/patriciogonzalezvivo/thebookofshaders```](https://github.com/patriciogonzalezvivo/thebookofshaders). Перегляньте в ньому файли та теки. Ви помітите, що контент знаходиться в ```README.md``` та інших файлах з назвами із великих літер, наприклад: ```TITLE.md```, ```SUMMARY.md``` тощо. Також зауважте, що переклади розміщуються у файлах, імена яких закінчуються додатковими двома літерами, що вказують на мову перекладу, наприклад: ```README-jp.md```, ```README-es.md``` тощо.

2. Зробіть відгалуження репозиторію і клонуйте його на свій комп'ютер.

3. Продублюйте вміст файлів, які потрібно перекласти. Додайте до них двобуквенний код, що буде вказувати на мову для якої ви робите переклад.

4. Перекладіть вміст файлу (див. **Примітки щодо перекладу**).

5. Протестуйте зміни (див. **Тестування**).

6. Зробіть push у ваш власний форк проєкту і створіть [pull request](https://help.github.com/articles/using-pull-requests/)

#### Примітки щодо перекладу

Не видаляйте та не змінюйте вбудовані приклади, які виглядають приблизно так:

```html
<div class="codeAndCanvas" data="grid-making.frag"></div>
```

Або так:

```html
<div class="simpleFunction" data="y = mod(x,2.0);"></div>
```

#### Тестування

Запустіть локальний PHP-сервер у теці локального репозиторію:

```bash
php -S localhost:8000
```

Тепер у вашому браузері зайдіть на адресу [```localhost:8000```](http://localhost:8000), перейдіть до розділу, який ви перекладаєте, і додайте в кінці адреси такий рядок ```?lan=```, а після нього дві літери для позначення мови перекладу.

Наприклад, якщо ви перекладаєте розділ ```03``` на французьку мову, значить ви працювали з файлом ```03/README-fr.md```, і ви можете перевірити його за адресою: ``` http://localhost:8000/03/?lan=fr```

### Покращення глосарію

Цей розділ знаходиться в розробці. Ми раді вислухати ваші ідеї щодо його покращення, щоб зробити його корисним інструментом для всіх. Надсилайте свої пропозиції на [@bookofshaders](https://twitter.com/bookofshaders).

### Редагування контенту

Ми всі люди. Якщо ви побачите помилку, то сповістіть про неї, зробіть pull-request з виправленням або відкрийте issue. Дякую!

### Діліться своїми прикладами шейдерів

Ви побачите багато посилань на [онлайн-редактор](http://editor.thebookofshaders.com/) і його вбудовані у сторінки приклади з кодом.
Коли ви закодуєте щось корисне чи цікаве, натисніть «Export» (або піктограму ```⇪```) і надішліть його на адресу [@bookofshaders](https://twitter.com/bookofshaders) або [@kyndinfo](https://twitter.com/kyndinfo). Ми будемо раді переглянути його і додати до [галереї прикладів](https://thebookofshaders.com/examples/).
