## atan
Повертає арктангенс параметрів

### Оголошення
```glsl
float atan(float y, float x)  
vec2 atan(vec2 y, vec2 x)  
vec3 atan(vec3 y, vec3 x)  
vec4 atan(vec4 y, vec4 x)

float atan(float y_over_x)  
vec2 atan(vec2 y_over_x)  
vec3 atan(vec3 y_over_x)  
vec4 atan(vec4 y_over_x)
```

### Параметри
**```y```** — чисельник дробу, арктангенс якого потрібно повернути.

**```x```** — знаменник дробу, арктангенс якого потрібно повернути.

**```y_over_x```** — дріб, арктангенс якого потрібно повернути.

### Опис
**```atan()```** повертає кут, тригонометричний арктангенс якого дорівнює **`y,x`** або **`y_over_x`**, залежно від того, яке саме перевантаження функції викликається.

У першому перевантаженні знаки **`y`** і **`x`** використовуються для визначення квадранта, в якому лежить кут. Значення, які повертає **`atan`** у цьому випадку, знаходяться в діапазоні від -PI до PI. Результати не визначені, якщо **`x`** дорівнює нулю.

Для другого перевантаження **```atan()```** повертає кут, тангенс якого дорівнює **```y_over_x```**. Значення, що повертаються в цьому випадку, знаходяться в діапазоні від -PI до PI.

### Дивіться також
[cos](/glossary/?lan=ua&search=cos), [acos](/glossary/?lan=ua&search=acos), [sin](/glossary/?lan=ua&search=sin), [asin](/glossary/?lan=ua&search=asin), [atan](/glossary/?lan=ua&search=atan), [Розділ 05: Формотворчі функції](/05/?lan=ua), [Розділ 06: Кольори](/06/?lan=ua)
