## textureCube
Отримує текселі (texels) з текстури

### Оголошення
```glsl
vec4 textureCube(samplerCube sampler, vec3 coord)  
vec4 textureCube(samplerCube sampler, vec3 coord, float bias)
```

### Параметри
**```sampler```** — семплер, до якого прив'язана текстура, з якої будуть отримані текселі.

**```coord```** — координати текстури, за якими буде взята текстура.

**```bias```** — необов'язкове зміщення, яке буде застосовано під час обчислення рівня деталізації.

### Опис
Функція **`textureCube`** повертає тексель, тобто значення (кольору) текстури для заданих координат. Функція має перший вхідний параметр типу **`samplerCube`** і другий вхідний параметр типу **`vec3`**: семплер, до якої прив'язана текстура, і тривимірні координати текселя.

Існує додатковий третій вхідний параметр типу **`float`**. Після обчислення відповідного рівня деталізації для текстури з MIP-картами зміщення додається перед виконанням фактичної операції пошуку текстури.

Додаткова примітка: на пристроях iOS функція пошуку текстури доступна лише у фрагментному шейдері.

### Дивіться також
[texture2D](/glossary/?lan=ua&search=texture2D)
